(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     71111,       1340]
NotebookOptionsPosition[     69435,       1304]
NotebookOutlinePosition[     69857,       1321]
CellTagsIndexPosition[     69814,       1318]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[TextData[{
 StyleBox["Peta4",
  FontColor->RGBColor[0.5, 0, 0.5]],
 " survey notebook"
}], "Title",
 CellChangeTimes->{{3.856165344530184*^9, 3.856165360586437*^9}, {
  3.856592043342741*^9, 3.8565920465891027`*^9}, {3.8609516060411243`*^9, 
  3.860951619657099*^9}},ExpressionUUID->"77b3805d-060b-4070-8508-\
41576cdf0004"],

Cell["\<\
This notebook generates a Wolfram language file to be run locally, or on a \
suitable login node. It prepares batches of theories for the HiGGS \
Commissioning Survey.\
\>", "Text",
 CellChangeTimes->{{3.85659205646922*^9, 3.8565920652907*^9}, {
  3.860951679512435*^9, 3.860951682616518*^9}, {3.8609590637671432`*^9, 
  3.860959119045631*^9}},ExpressionUUID->"ac3b952a-323b-405e-9ac1-\
f072cdc53b32"],

Cell[BoxData[{
 RowBox[{"Run", "@", "\"\<rm -rf ./svy/node-*\>\""}], "\[IndentingNewLine]", 
 RowBox[{"Run", "@", "\"\<rm -rf ./svy\>\""}], "\[IndentingNewLine]", 
 RowBox[{"Run", "@", "\"\<mkdir ./svy\>\""}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.860399987586609*^9, 3.860400012970598*^9}, {
  3.860429185749961*^9, 3.860429188165661*^9}, {3.860429233165124*^9, 
  3.860429246557065*^9}, {3.860963072662879*^9, 3.8609630732779293`*^9}, {
  3.860963191132722*^9, 
  3.860963202620644*^9}},ExpressionUUID->"68ab92ad-3c68-4108-8669-\
f32b9f7a052f"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RawJobsBatch", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\"\<spin_0p\>\"", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Alp1", "==", "0"}], ",", 
         RowBox[{"Alp2", "==", "0"}], ",", 
         RowBox[{"Alp3", "==", "0"}], ",", 
         RowBox[{"Alp4", "==", "0"}], ",", 
         RowBox[{"Alp5", "==", "0"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"2", "Bet1"}], "+", "Bet2"}], "==", "0"}], ",", 
         RowBox[{
          RowBox[{"Bet1", "+", 
           RowBox[{"2", "Bet3"}]}], "==", "0"}]}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<spin_0m\>\"", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Alp1", "==", "0"}], ",", 
         RowBox[{"Alp2", "==", "0"}], ",", 
         RowBox[{"Alp4", "==", "0"}], ",", 
         RowBox[{"Alp5", "==", "0"}], ",", 
         RowBox[{"Alp6", "==", "0"}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"2", "Bet1"}], "+", "Bet2"}], "==", "0"}], ",", 
         RowBox[{
          RowBox[{"Bet1", "+", 
           RowBox[{"2", "Bet3"}]}], "==", "0"}]}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<simple_spin_1p\>\"", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Alp1", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp2", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp3", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp4", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp6", "\[Equal]", "0"}], ",", 
         RowBox[{"Bet1", "==", "0"}], ",", 
         RowBox[{"Bet2", "\[Equal]", "0"}], ",", 
         RowBox[{"cAlp1", "==", "0"}], ",", 
         RowBox[{"cAlp2", "\[Equal]", "0"}], ",", 
         RowBox[{"cAlp5", "\[Equal]", "0"}]}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<simple_spin_1m\>\"", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Alp1", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp2", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp3", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp4", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp6", "\[Equal]", "0"}], ",", 
         RowBox[{"Bet1", "==", "0"}], ",", 
         RowBox[{"Bet3", "\[Equal]", "0"}], ",", 
         RowBox[{"cAlp1", "\[Equal]", "0"}], ",", 
         RowBox[{"cAlp2", "\[Equal]", "0"}], ",", 
         RowBox[{"cAlp4", "\[Equal]", "0"}], ",", 
         RowBox[{"cAlp5", "\[Equal]", "0"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<simple_spin_2m\>\"", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Alp2", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp3", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp4", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp5", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp6", "\[Equal]", "0"}], ",", 
         RowBox[{"Bet1", "==", "0"}], ",", 
         RowBox[{"Bet2", "\[Equal]", "0"}], ",", 
         RowBox[{"Bet3", "\[Equal]", "0"}], ",", 
         RowBox[{"cAlp1", "==", "0"}], ",", 
         RowBox[{"cAlp2", "\[Equal]", "0"}], ",", 
         RowBox[{"cAlp4", "\[Equal]", "0"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<simple_spin_1p\>\"", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Alp1", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp2", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp3", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp4", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp6", "\[Equal]", "0"}], ",", 
         RowBox[{"Bet1", "==", "0"}], ",", 
         RowBox[{"Bet2", "\[Equal]", "0"}], ",", 
         RowBox[{"cAlp1", "\[Equal]", "0"}], ",", 
         RowBox[{"cAlp2", "\[Equal]", "0"}], ",", 
         RowBox[{"cAlp5", "\[Equal]", "0"}]}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<simple_spin_1m\>\"", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Alp2", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp2", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp3", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp4", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp6", "\[Equal]", "0"}], ",", 
         RowBox[{"Bet1", "==", "0"}], ",", 
         RowBox[{"Bet3", "\[Equal]", "0"}], ",", 
         RowBox[{"cAlp1", "\[Equal]", "0"}], ",", 
         RowBox[{"cAlp4", "\[Equal]", "0"}], ",", 
         RowBox[{"cAlp5", "\[Equal]", "0"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<simple_spin_2m\>\"", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Alp2", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp3", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp4", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp5", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp6", "\[Equal]", "0"}], ",", 
         RowBox[{"Bet1", "==", "0"}], ",", 
         RowBox[{"Bet2", "\[Equal]", "0"}], ",", 
         RowBox[{"Bet3", "\[Equal]", "0"}], ",", 
         RowBox[{"cAlp1", "==", "0"}], ",", 
         RowBox[{"cAlp2", "\[Equal]", "0"}], ",", 
         RowBox[{"cAlp4", "\[Equal]", "0"}]}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<simple_spin_0-2m_a\>\"", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Alp1", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp3", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp4", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp5", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp6", "\[Equal]", "0"}], ",", 
         RowBox[{"Bet1", "==", "0"}], ",", 
         RowBox[{"Bet2", "\[Equal]", "0"}], ",", 
         RowBox[{"Bet3", "\[Equal]", "0"}]}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<simple_spin_0-2m_b\>\"", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Alp2", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp4", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp5", "\[Equal]", "0"}], ",", 
         RowBox[{"Alp6", "\[Equal]", "0"}], ",", 
         RowBox[{"Bet1", "==", "0"}], ",", 
         RowBox[{"Bet2", "\[Equal]", "0"}], ",", 
         RowBox[{"Bet3", "\[Equal]", "0"}]}], "}"}]}], "}"}]}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.8561134940016623`*^9, 3.856113563953445*^9}, {
   3.856113864152964*^9, 3.856113866735909*^9}, {3.856114686146227*^9, 
   3.856114722201364*^9}, {3.8561147534818153`*^9, 3.856114786785334*^9}, {
   3.8561150379530697`*^9, 3.8561150382066393`*^9}, {3.856115132575592*^9, 
   3.856115149455024*^9}, 3.856165332453063*^9, {3.856165412953887*^9, 
   3.856165493969346*^9}, {3.856165882551499*^9, 3.8561659681267014`*^9}, {
   3.856252550417321*^9, 3.856252550671973*^9}, {3.856253384785056*^9, 
   3.856253537238635*^9}, {3.856253871827731*^9, 3.856253912977112*^9}, {
   3.856266135351696*^9, 3.85626613949498*^9}, {3.856330112716134*^9, 
   3.856330148356846*^9}, {3.856334077806583*^9, 3.85633412540273*^9}, {
   3.8563374211690483`*^9, 3.8563375146333323`*^9}, {3.8563713031675777`*^9, 
   3.8563713066542683`*^9}, {3.856407380427725*^9, 3.856407391803412*^9}, {
   3.856407608764429*^9, 3.8564076196720247`*^9}, 3.856407752091467*^9, 
   3.856407826016653*^9, 3.856407902750139*^9, {3.85640794860667*^9, 
   3.8564079506166077`*^9}, {3.8564080331074467`*^9, 3.856408035278562*^9}, 
   3.856408749583098*^9, {3.8564088204491577`*^9, 3.856408851243552*^9}, {
   3.856408937610999*^9, 3.856408958571206*^9}, 3.856426594371249*^9, {
   3.856546771934794*^9, 3.856546780533009*^9}, {3.856547050566327*^9, 
   3.856547182411356*^9}, {3.8565472180334578`*^9, 3.8565472297545033`*^9}, {
   3.856547261019403*^9, 3.856547319535778*^9}, {3.856547389634677*^9, 
   3.856547415811049*^9}, {3.856547502452675*^9, 3.8565475402935333`*^9}, {
   3.856547935615954*^9, 3.856547996958641*^9}, {3.8565480427427683`*^9, 
   3.856548130126974*^9}, {3.856548174271737*^9, 3.856548238495077*^9}, {
   3.856548994305244*^9, 3.856549018994968*^9}, {3.856549639533609*^9, 
   3.856549677197238*^9}, {3.856550750202263*^9, 3.856550754237236*^9}, {
   3.856584484801955*^9, 3.856584543913227*^9}, {3.856584817941999*^9, 
   3.856584869979888*^9}, 3.856585073668594*^9, {3.85658620385732*^9, 
   3.856586205956044*^9}, {3.856588920521818*^9, 3.856588921557769*^9}, 
   3.856588960476514*^9, {3.856590039993527*^9, 3.85659006622727*^9}, {
   3.856593936282866*^9, 3.856593948507574*^9}, {3.856593995428607*^9, 
   3.856593999792821*^9}, {3.856594042031241*^9, 3.856594053246723*^9}, {
   3.856594086439999*^9, 3.856594226084935*^9}, {3.85659432821384*^9, 
   3.856594469940914*^9}, {3.856594500282078*^9, 3.856594544618071*^9}, {
   3.856594612259853*^9, 3.856594769070032*^9}, {3.856594873905396*^9, 
   3.856594956693438*^9}, {3.8565950194680347`*^9, 3.856595074756282*^9}, {
   3.856595284751771*^9, 3.856595285285953*^9}, {3.856595383481922*^9, 
   3.856595426680007*^9}, {3.856596034870791*^9, 3.8565960350298347`*^9}, {
   3.85659607209651*^9, 3.85659608586699*^9}, {3.8565965701300287`*^9, 
   3.856596638947892*^9}, {3.856596725375925*^9, 3.856596731990838*^9}, {
   3.856598251369217*^9, 3.856598258241246*^9}, {3.856598434570442*^9, 
   3.856598462529182*^9}, {3.85659873835382*^9, 3.85659873866574*^9}, 
   3.856598824236*^9, {3.856598867332992*^9, 3.856598962700162*^9}, {
   3.8565990452773323`*^9, 3.856599068467422*^9}, {3.8565991551085377`*^9, 
   3.8565993229007053`*^9}, {3.8565993536914263`*^9, 3.856599417248561*^9}, {
   3.856600138751534*^9, 3.8566001661422253`*^9}, {3.8566002060986834`*^9, 
   3.856600225334676*^9}, {3.856600544026388*^9, 3.8566005441484118`*^9}, {
   3.856600586409638*^9, 3.856600612088909*^9}, {3.856600663947249*^9, 
   3.856600689908874*^9}, {3.856600745930562*^9, 3.8566008026048613`*^9}, {
   3.8566010638589973`*^9, 3.856601092986932*^9}, {3.85660138015917*^9, 
   3.8566013877983093`*^9}, {3.856606601818824*^9, 3.856606632750181*^9}, {
   3.856606721016076*^9, 3.856606801080719*^9}, {3.856607075354292*^9, 
   3.8566070793089247`*^9}, {3.856607285519328*^9, 3.856607350667756*^9}, {
   3.8566074599074087`*^9, 3.85660763592397*^9}, {3.856615179405943*^9, 
   3.856615210040922*^9}, {3.856630195894566*^9, 3.856630253259329*^9}, {
   3.8566931344471893`*^9, 3.856693204813795*^9}, 3.856693305118594*^9, {
   3.856693563355632*^9, 3.856693567190674*^9}, {3.856693669447075*^9, 
   3.8566936779144287`*^9}, {3.8566938062708397`*^9, 3.856693808318098*^9}, {
   3.8566939398466473`*^9, 3.856693942230942*^9}, {3.856697869620206*^9, 
   3.856697873773686*^9}, {3.856698360189404*^9, 3.856698371872653*^9}, {
   3.856700875553402*^9, 3.8567008771913757`*^9}, {3.8567019896412363`*^9, 
   3.856701992163899*^9}, {3.856702058555892*^9, 3.856702093022097*^9}, {
   3.8567024693164377`*^9, 3.856702472672245*^9}, {3.856702662221097*^9, 
   3.8567026639724407`*^9}, {3.856702933353261*^9, 3.856702937571703*^9}, {
   3.856702969037169*^9, 3.8567029816901608`*^9}, {3.856703272825307*^9, 
   3.8567032770478907`*^9}, {3.856703434516992*^9, 3.856703449079845*^9}, {
   3.856703764231814*^9, 3.856703769679906*^9}, {3.85670523350788*^9, 
   3.856705255121399*^9}, {3.856705300802005*^9, 3.8567053440432377`*^9}, 
   3.8567053835308113`*^9, {3.856716776053294*^9, 3.856716798617839*^9}, {
   3.856717296675805*^9, 3.856717300454899*^9}, {3.856717455235383*^9, 
   3.856717459302205*^9}, {3.856717558228253*^9, 3.856717577490952*^9}, {
   3.856766079861846*^9, 3.856766199328062*^9}, {3.856768657046853*^9, 
   3.856768658811205*^9}, {3.856768689609551*^9, 3.8567687186879473`*^9}, {
   3.856847824059163*^9, 3.856847829756719*^9}, {3.856885056781955*^9, 
   3.8568850572425117`*^9}, {3.8568875962693453`*^9, 3.856887605235325*^9}, {
   3.8569364364172297`*^9, 3.856936438322406*^9}, {3.8569572256026897`*^9, 
   3.856957232048373*^9}, {3.858142966335279*^9, 3.858142967860476*^9}, {
   3.85818112692178*^9, 3.8581811377360287`*^9}, {3.858181271677498*^9, 
   3.8581812782539043`*^9}, 3.858181354071229*^9, {3.858181524199338*^9, 
   3.858181555061183*^9}, 3.858181602086733*^9, {3.858181671389921*^9, 
   3.858181758453566*^9}, {3.858181924587641*^9, 3.858181926451866*^9}, {
   3.858181962742115*^9, 3.858181972902639*^9}, {3.8581820085582523`*^9, 
   3.8581820428319693`*^9}, {3.858182313602854*^9, 3.858182318711783*^9}, 
   3.858182736132729*^9, {3.858182873156907*^9, 3.858182876713172*^9}, {
   3.858184058358448*^9, 3.858184060194497*^9}, {3.858184214826552*^9, 
   3.8581842270070047`*^9}, {3.858184821147771*^9, 3.858184822231308*^9}, {
   3.8581858194322453`*^9, 3.85818582401626*^9}, {3.8582267013467503`*^9, 
   3.8582267055196037`*^9}, 3.858228301091529*^9, {3.858229492565473*^9, 
   3.8582295062000647`*^9}, {3.8582296669434967`*^9, 
   3.8582297318074417`*^9}, {3.8582301400178213`*^9, 
   3.8582301519399233`*^9}, {3.8582307301490602`*^9, 3.858230772531424*^9}, {
   3.858231510513658*^9, 3.858231523827112*^9}, {3.858233464638513*^9, 
   3.8582334712864532`*^9}, {3.8582336759973717`*^9, 
   3.8582336788817043`*^9}, {3.8582343296727877`*^9, 3.858234401096449*^9}, 
   3.858234510434876*^9, {3.858235066237193*^9, 3.8582350738367023`*^9}, {
   3.858235202140679*^9, 3.858235220235373*^9}, {3.858235454699109*^9, 
   3.858235467892789*^9}, {3.858236200960024*^9, 3.858236217929487*^9}, {
   3.858236832559057*^9, 3.858236840867004*^9}, {3.858238575009941*^9, 
   3.85823861822012*^9}, {3.8582393686107492`*^9, 3.8582393946451683`*^9}, {
   3.858239531711216*^9, 3.858239538715068*^9}, {3.8582397821401167`*^9, 
   3.858239782385582*^9}, {3.858243501836114*^9, 3.858243533066533*^9}, 
   3.8582517677726316`*^9, {3.858253141465578*^9, 3.858253156004655*^9}, {
   3.858262523424046*^9, 3.8582625263262672`*^9}, {3.8582626132154093`*^9, 
   3.858262651990097*^9}, {3.858263093996423*^9, 3.858263107363203*^9}, {
   3.858269621613408*^9, 3.8582696456949043`*^9}, {3.858270163378757*^9, 
   3.858270173825705*^9}, {3.8582710242137823`*^9, 3.858271030036566*^9}, {
   3.858339575377823*^9, 3.858339606721662*^9}, {3.858342927878196*^9, 
   3.8583429658853207`*^9}, {3.858433836920229*^9, 3.8584338580792007`*^9}, {
   3.858444408381193*^9, 3.858444410492931*^9}, {3.858488493308608*^9, 
   3.858488497917211*^9}, {3.858488536588729*^9, 3.8584885507801733`*^9}, {
   3.858489530903399*^9, 3.858489533822534*^9}, {3.858490078702059*^9, 
   3.858490081194944*^9}, {3.8584935454650297`*^9, 3.858493546463683*^9}, {
   3.858493586904846*^9, 3.8584936478150787`*^9}, {3.858495601141667*^9, 
   3.858495607299471*^9}, {3.858496325240609*^9, 3.858496327438936*^9}, 
   3.858497286249983*^9, {3.858498767025363*^9, 3.858498795672372*^9}, {
   3.858499119271175*^9, 3.8584991240866756`*^9}, {3.858510475487196*^9, 
   3.8585104773659773`*^9}, {3.858510663777513*^9, 3.8585107203833313`*^9}, {
   3.858510766166922*^9, 3.858510819231451*^9}, {3.858514732542738*^9, 
   3.858514775339328*^9}, {3.858524787588656*^9, 3.858524805815624*^9}, {
   3.858586280769*^9, 3.858586320902526*^9}, {3.8586041766885843`*^9, 
   3.858604235656663*^9}, {3.858604268024601*^9, 3.8586043932366858`*^9}, {
   3.8586756463415127`*^9, 3.858675658869523*^9}, {3.858693513549828*^9, 
   3.858693520322974*^9}, {3.858707622178495*^9, 3.858707625882985*^9}, {
   3.858713068848999*^9, 3.858713111616528*^9}, {3.8587397670160303`*^9, 
   3.85873976882025*^9}, {3.8587675401932583`*^9, 3.858767541652359*^9}, {
   3.858832057428598*^9, 3.858832057926138*^9}, {3.858837232206874*^9, 
   3.858837233645618*^9}, {3.858853493013969*^9, 3.8588535088894873`*^9}, 
   3.858855124164269*^9, {3.8588564226327744`*^9, 3.858856431548901*^9}, 
   3.8589136332742987`*^9, 3.858919114696944*^9, 3.85893209743512*^9, 
   3.858945274840987*^9, {3.858952938922271*^9, 3.858952942944778*^9}, 
   3.8589531113849363`*^9, 3.858995404369176*^9, {3.8589956417225437`*^9, 
   3.858995644914462*^9}, {3.8590358762954283`*^9, 3.85903590700359*^9}, {
   3.859091432673786*^9, 3.8590914661578608`*^9}, 3.859117315940999*^9, 
   3.859146655027433*^9, {3.859172984765532*^9, 3.859172993171767*^9}, {
   3.8592159531931887`*^9, 3.859215953986575*^9}, {3.859617013949033*^9, 
   3.8596170867982264`*^9}, {3.85970281276968*^9, 3.85970281470197*^9}, {
   3.859742016589634*^9, 3.8597420216673613`*^9}, {3.8597835044637527`*^9, 
   3.8597835199839087`*^9}, {3.8597911002859983`*^9, 3.859791100724319*^9}, 
   3.860040870391541*^9, 3.860044767183367*^9, {3.8600501884979267`*^9, 
   3.860050190728992*^9}, {3.860050222695786*^9, 3.860050240304451*^9}, {
   3.860051976431161*^9, 3.860051976698119*^9}, {3.86007842241339*^9, 
   3.860078422741357*^9}, {3.86007958297482*^9, 3.860079589892458*^9}, {
   3.860254795985964*^9, 3.860254796273282*^9}, {3.8603905581247187`*^9, 
   3.86039056046061*^9}, {3.860392391857956*^9, 3.860392410433288*^9}, {
   3.860392737542636*^9, 3.860392743422007*^9}, 3.8603945110445967`*^9, {
   3.8603946230506077`*^9, 3.860394676904513*^9}, {3.860394826113806*^9, 
   3.86039485469093*^9}, {3.860395042709858*^9, 3.8603951368367023`*^9}, {
   3.8603952881392927`*^9, 3.8603953394026213`*^9}, {3.860395388202415*^9, 
   3.860395388656404*^9}, {3.860395441778183*^9, 3.8603954737003*^9}, {
   3.860689669639132*^9, 3.860689691189103*^9}, {3.860689730996731*^9, 
   3.860689768883831*^9}, {3.860823241671157*^9, 3.860823241832*^9}, {
   3.86082391171447*^9, 3.8608239197824507`*^9}, {3.862041516969472*^9, 
   3.862041537208737*^9}, {3.862041609655591*^9, 3.862041615504018*^9}, 
   3.862053155497725*^9, {3.862053374713518*^9, 3.8620533978007183`*^9}, {
   3.8620537893865013`*^9, 3.8620538489251757`*^9}, {3.862053886711789*^9, 
   3.862053893228517*^9}, {3.862058886018509*^9, 3.862058889338594*^9}, {
   3.862058971354989*^9, 3.8620589744462833`*^9}, 3.862062010417149*^9, 
   3.862065882026348*^9, {3.862077421785433*^9, 3.862077424870319*^9}, {
   3.862118549649253*^9, 3.862118552336906*^9}, 3.862118583328816*^9, {
   3.862124875270627*^9, 3.8621248779942913`*^9}, 3.862129782649626*^9, {
   3.862136583011747*^9, 3.8621365874280367`*^9}, 3.862136780685607*^9, 
   3.862309157389801*^9, {3.862309388203762*^9, 3.8623093883235617`*^9}, 
   3.862345426233416*^9, {3.86241137106078*^9, 3.862411372850412*^9}, 
   3.8624114533054733`*^9, {3.862414749323365*^9, 
   3.8624147495359583`*^9}},ExpressionUUID->"e2c58913-e1e8-4976-9444-\
297f506ffb31"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"calibratoin", " ", "survey"}], ",", " ", 
    RowBox[{
     RowBox[{"Yo", "&"}], "Nester", " ", "over", " ", "10", " ", "nodes"}]}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
   "remember", " ", "to", " ", "really", " ", "calibrate", " ", "you", " ", 
    "will", " ", "want", " ", "to", " ", "disable", " ", "the", " ", 
    "multipliers", " ", 
    RowBox[{"again", "!"}]}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"node", "=", "0"}], ",", 
      RowBox[{"node", "<", "10"}], ",", 
      RowBox[{"node", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"JobsBatch", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"#", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "<>", "\"\<_node_\>\"", "<>", 
              RowBox[{"ToString", "@", "node"}]}], ",", 
             RowBox[{"#", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], "}"}], ")"}], "&"}], "/@", 
         "RawJobsBatch"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Run", "@", 
        RowBox[{"(", 
         RowBox[{"\"\<mkdir ./svy/node-\>\"", "<>", 
          RowBox[{"ToString", "@", "node"}]}], ")"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Run", "@", 
        RowBox[{"(", 
         RowBox[{"\"\<mkdir ./svy/node-\>\"", "<>", 
          RowBox[{"ToString", "@", "node"}], "<>", "\"\</chr\>\""}], ")"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"FileNameJoin", "@", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Directory", "[", "]"}], ",", 
           RowBox[{"\"\<svy/node-\>\"", "<>", 
            RowBox[{"ToString", "@", "node"}]}], ",", 
           "\"\<JobsBatch.mx\>\""}], "}"}]}], "~", "DumpSave", "~", 
        RowBox[{"{", "JobsBatch", "}"}]}], ";"}]}], "\[IndentingNewLine]", 
     "]"}], ";"}], "\[IndentingNewLine]", "*)"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.8561134940016623`*^9, 3.856113563953445*^9}, {
   3.856113864152964*^9, 3.856113866735909*^9}, {3.856114686146227*^9, 
   3.856114722201364*^9}, {3.8561147534818153`*^9, 3.856114786785334*^9}, {
   3.8561150379530697`*^9, 3.8561150382066393`*^9}, {3.856115132575592*^9, 
   3.856115149455024*^9}, 3.856165332453063*^9, {3.856165412953887*^9, 
   3.856165493969346*^9}, {3.856165882551499*^9, 3.8561659681267014`*^9}, {
   3.856252550417321*^9, 3.856252550671973*^9}, {3.856253384785056*^9, 
   3.856253537238635*^9}, {3.856253871827731*^9, 3.856253912977112*^9}, {
   3.856266135351696*^9, 3.85626613949498*^9}, {3.856330112716134*^9, 
   3.856330148356846*^9}, {3.856334077806583*^9, 3.85633412540273*^9}, {
   3.8563374211690483`*^9, 3.8563375146333323`*^9}, {3.8563713031675777`*^9, 
   3.8563713066542683`*^9}, {3.856407380427725*^9, 3.856407391803412*^9}, {
   3.856407608764429*^9, 3.8564076196720247`*^9}, 3.856407752091467*^9, 
   3.856407826016653*^9, 3.856407902750139*^9, {3.85640794860667*^9, 
   3.8564079506166077`*^9}, {3.8564080331074467`*^9, 3.856408035278562*^9}, 
   3.856408749583098*^9, {3.8564088204491577`*^9, 3.856408851243552*^9}, {
   3.856408937610999*^9, 3.856408958571206*^9}, 3.856426594371249*^9, {
   3.856546771934794*^9, 3.856546780533009*^9}, {3.856547050566327*^9, 
   3.856547182411356*^9}, {3.8565472180334578`*^9, 3.8565472297545033`*^9}, {
   3.856547261019403*^9, 3.856547319535778*^9}, {3.856547389634677*^9, 
   3.856547415811049*^9}, {3.856547502452675*^9, 3.8565475402935333`*^9}, {
   3.856547935615954*^9, 3.856547996958641*^9}, {3.8565480427427683`*^9, 
   3.856548130126974*^9}, {3.856548174271737*^9, 3.856548238495077*^9}, {
   3.856548994305244*^9, 3.856549018994968*^9}, {3.856549639533609*^9, 
   3.856549677197238*^9}, {3.856550750202263*^9, 3.856550754237236*^9}, {
   3.856584484801955*^9, 3.856584543913227*^9}, {3.856584817941999*^9, 
   3.856584869979888*^9}, 3.856585073668594*^9, {3.85658620385732*^9, 
   3.856586205956044*^9}, {3.856588920521818*^9, 3.856588921557769*^9}, 
   3.856588960476514*^9, {3.856590039993527*^9, 3.85659006622727*^9}, {
   3.856593936282866*^9, 3.856593948507574*^9}, {3.856593995428607*^9, 
   3.856593999792821*^9}, {3.856594042031241*^9, 3.856594053246723*^9}, {
   3.856594086439999*^9, 3.856594226084935*^9}, {3.85659432821384*^9, 
   3.856594469940914*^9}, {3.856594500282078*^9, 3.856594544618071*^9}, {
   3.856594612259853*^9, 3.856594769070032*^9}, {3.856594873905396*^9, 
   3.856594956693438*^9}, {3.8565950194680347`*^9, 3.856595074756282*^9}, {
   3.856595284751771*^9, 3.856595285285953*^9}, {3.856595383481922*^9, 
   3.856595426680007*^9}, {3.856596034870791*^9, 3.8565960350298347`*^9}, {
   3.85659607209651*^9, 3.85659608586699*^9}, {3.8565965701300287`*^9, 
   3.856596638947892*^9}, {3.856596725375925*^9, 3.856596731990838*^9}, {
   3.856598251369217*^9, 3.856598258241246*^9}, {3.856598434570442*^9, 
   3.856598462529182*^9}, {3.85659873835382*^9, 3.85659873866574*^9}, 
   3.856598824236*^9, {3.856598867332992*^9, 3.856598962700162*^9}, {
   3.8565990452773323`*^9, 3.856599068467422*^9}, {3.8565991551085377`*^9, 
   3.8565993229007053`*^9}, {3.8565993536914263`*^9, 3.856599417248561*^9}, {
   3.856600138751534*^9, 3.8566001661422253`*^9}, {3.8566002060986834`*^9, 
   3.856600225334676*^9}, {3.856600544026388*^9, 3.8566005441484118`*^9}, {
   3.856600586409638*^9, 3.856600612088909*^9}, {3.856600663947249*^9, 
   3.856600689908874*^9}, {3.856600745930562*^9, 3.8566008026048613`*^9}, {
   3.8566010638589973`*^9, 3.856601092986932*^9}, {3.85660138015917*^9, 
   3.8566013877983093`*^9}, {3.856606601818824*^9, 3.856606632750181*^9}, {
   3.856606721016076*^9, 3.856606801080719*^9}, {3.856607075354292*^9, 
   3.8566070793089247`*^9}, {3.856607285519328*^9, 3.856607350667756*^9}, {
   3.8566074599074087`*^9, 3.85660763592397*^9}, {3.856615179405943*^9, 
   3.856615210040922*^9}, {3.856630195894566*^9, 3.856630253259329*^9}, {
   3.8566931344471893`*^9, 3.856693204813795*^9}, 3.856693305118594*^9, {
   3.856693563355632*^9, 3.856693567190674*^9}, {3.856693669447075*^9, 
   3.8566936779144287`*^9}, {3.8566938062708397`*^9, 3.856693808318098*^9}, {
   3.8566939398466473`*^9, 3.856693942230942*^9}, {3.856697869620206*^9, 
   3.856697873773686*^9}, {3.856698360189404*^9, 3.856698371872653*^9}, {
   3.856700875553402*^9, 3.8567008771913757`*^9}, {3.8567019896412363`*^9, 
   3.856701992163899*^9}, {3.856702058555892*^9, 3.856702093022097*^9}, {
   3.8567024693164377`*^9, 3.856702472672245*^9}, {3.856702662221097*^9, 
   3.8567026639724407`*^9}, {3.856702933353261*^9, 3.856702937571703*^9}, {
   3.856702969037169*^9, 3.8567029816901608`*^9}, {3.856703272825307*^9, 
   3.8567032770478907`*^9}, {3.856703434516992*^9, 3.856703449079845*^9}, {
   3.856703764231814*^9, 3.856703769679906*^9}, {3.85670523350788*^9, 
   3.856705255121399*^9}, {3.856705300802005*^9, 3.8567053440432377`*^9}, 
   3.8567053835308113`*^9, {3.856716776053294*^9, 3.856716798617839*^9}, {
   3.856717296675805*^9, 3.856717300454899*^9}, {3.856717455235383*^9, 
   3.856717459302205*^9}, {3.856717558228253*^9, 3.856717577490952*^9}, {
   3.856766079861846*^9, 3.856766199328062*^9}, {3.856768657046853*^9, 
   3.856768658811205*^9}, {3.856768689609551*^9, 3.8567687186879473`*^9}, {
   3.856847824059163*^9, 3.856847829756719*^9}, {3.856885056781955*^9, 
   3.8568850572425117`*^9}, {3.8568875962693453`*^9, 3.856887605235325*^9}, {
   3.8569364364172297`*^9, 3.856936438322406*^9}, {3.8569572256026897`*^9, 
   3.856957232048373*^9}, {3.858142966335279*^9, 3.858142967860476*^9}, {
   3.85818112692178*^9, 3.8581811377360287`*^9}, {3.858181271677498*^9, 
   3.8581812782539043`*^9}, 3.858181354071229*^9, {3.858181524199338*^9, 
   3.858181555061183*^9}, 3.858181602086733*^9, {3.858181671389921*^9, 
   3.858181758453566*^9}, {3.858181924587641*^9, 3.858181926451866*^9}, {
   3.858181962742115*^9, 3.858181972902639*^9}, {3.8581820085582523`*^9, 
   3.8581820428319693`*^9}, {3.858182313602854*^9, 3.858182318711783*^9}, 
   3.858182736132729*^9, {3.858182873156907*^9, 3.858182876713172*^9}, {
   3.858184058358448*^9, 3.858184060194497*^9}, {3.858184214826552*^9, 
   3.8581842270070047`*^9}, {3.858184821147771*^9, 3.858184822231308*^9}, {
   3.8581858194322453`*^9, 3.85818582401626*^9}, {3.8582267013467503`*^9, 
   3.8582267055196037`*^9}, 3.858228301091529*^9, {3.858229492565473*^9, 
   3.8582295062000647`*^9}, {3.8582296669434967`*^9, 
   3.8582297318074417`*^9}, {3.8582301400178213`*^9, 
   3.8582301519399233`*^9}, {3.8582307301490602`*^9, 3.858230772531424*^9}, {
   3.858231510513658*^9, 3.858231523827112*^9}, {3.858233464638513*^9, 
   3.8582334712864532`*^9}, {3.8582336759973717`*^9, 
   3.8582336788817043`*^9}, {3.8582343296727877`*^9, 3.858234401096449*^9}, 
   3.858234510434876*^9, {3.858235066237193*^9, 3.8582350738367023`*^9}, {
   3.858235202140679*^9, 3.858235220235373*^9}, {3.858235454699109*^9, 
   3.858235467892789*^9}, {3.858236200960024*^9, 3.858236217929487*^9}, {
   3.858236832559057*^9, 3.858236840867004*^9}, {3.858238575009941*^9, 
   3.85823861822012*^9}, {3.8582393686107492`*^9, 3.8582393946451683`*^9}, {
   3.858239531711216*^9, 3.858239538715068*^9}, {3.8582397821401167`*^9, 
   3.858239782385582*^9}, {3.858243501836114*^9, 3.858243533066533*^9}, 
   3.8582517677726316`*^9, {3.858253141465578*^9, 3.858253156004655*^9}, {
   3.858262523424046*^9, 3.8582625263262672`*^9}, {3.8582626132154093`*^9, 
   3.858262651990097*^9}, {3.858263093996423*^9, 3.858263107363203*^9}, {
   3.858269621613408*^9, 3.8582696456949043`*^9}, {3.858270163378757*^9, 
   3.858270173825705*^9}, {3.8582710242137823`*^9, 3.858271030036566*^9}, {
   3.858339575377823*^9, 3.858339606721662*^9}, {3.858342927878196*^9, 
   3.8583429658853207`*^9}, {3.858433836920229*^9, 3.8584338580792007`*^9}, {
   3.858444408381193*^9, 3.858444410492931*^9}, {3.858488493308608*^9, 
   3.858488497917211*^9}, {3.858488536588729*^9, 3.8584885507801733`*^9}, {
   3.858489530903399*^9, 3.858489533822534*^9}, {3.858490078702059*^9, 
   3.858490081194944*^9}, {3.8584935454650297`*^9, 3.858493546463683*^9}, {
   3.858493586904846*^9, 3.8584936478150787`*^9}, {3.858495601141667*^9, 
   3.858495607299471*^9}, {3.858496325240609*^9, 3.858496327438936*^9}, 
   3.858497286249983*^9, {3.858498767025363*^9, 3.858498795672372*^9}, {
   3.858499119271175*^9, 3.8584991240866756`*^9}, {3.858510475487196*^9, 
   3.8585104773659773`*^9}, {3.858510663777513*^9, 3.8585107203833313`*^9}, {
   3.858510766166922*^9, 3.858510819231451*^9}, {3.858514732542738*^9, 
   3.858514775339328*^9}, {3.858524787588656*^9, 3.858524805815624*^9}, {
   3.858586280769*^9, 3.858586320902526*^9}, {3.8586041766885843`*^9, 
   3.858604235656663*^9}, {3.858604268024601*^9, 3.8586043932366858`*^9}, {
   3.8586756463415127`*^9, 3.858675658869523*^9}, {3.858693513549828*^9, 
   3.858693520322974*^9}, {3.858707622178495*^9, 3.858707625882985*^9}, {
   3.858713068848999*^9, 3.858713111616528*^9}, {3.8587397670160303`*^9, 
   3.85873976882025*^9}, {3.8587675401932583`*^9, 3.858767541652359*^9}, {
   3.858832057428598*^9, 3.858832057926138*^9}, {3.858837232206874*^9, 
   3.858837233645618*^9}, {3.858853493013969*^9, 3.8588535088894873`*^9}, 
   3.858855124164269*^9, {3.8588564226327744`*^9, 3.858856431548901*^9}, 
   3.8589136332742987`*^9, 3.858919114696944*^9, 3.85893209743512*^9, 
   3.858945274840987*^9, {3.858952938922271*^9, 3.858952942944778*^9}, 
   3.8589531113849363`*^9, 3.858995404369176*^9, {3.8589956417225437`*^9, 
   3.858995644914462*^9}, {3.8590358762954283`*^9, 3.85903590700359*^9}, {
   3.859091432673786*^9, 3.8590914661578608`*^9}, 3.859117315940999*^9, 
   3.859146655027433*^9, {3.859172984765532*^9, 3.859172993171767*^9}, {
   3.8592159531931887`*^9, 3.859215953986575*^9}, {3.859617013949033*^9, 
   3.8596170867982264`*^9}, {3.85970281276968*^9, 3.85970281470197*^9}, {
   3.859742016589634*^9, 3.8597420216673613`*^9}, {3.8597835044637527`*^9, 
   3.8597835199839087`*^9}, {3.8597911002859983`*^9, 3.859791100724319*^9}, 
   3.860040870391541*^9, 3.860044767183367*^9, {3.8600501884979267`*^9, 
   3.860050190728992*^9}, {3.860050222695786*^9, 3.860050240304451*^9}, {
   3.860051976431161*^9, 3.860051976698119*^9}, {3.86007842241339*^9, 
   3.860078422741357*^9}, {3.86007958297482*^9, 3.860079589892458*^9}, {
   3.860254795985964*^9, 3.860254796273282*^9}, {3.8603905581247187`*^9, 
   3.86039056046061*^9}, {3.860392391857956*^9, 3.860392410433288*^9}, {
   3.860392737542636*^9, 3.860392743422007*^9}, 3.8603945110445967`*^9, {
   3.8603946230506077`*^9, 3.860394676904513*^9}, {3.860394826113806*^9, 
   3.86039485469093*^9}, {3.860395042709858*^9, 3.8603951368367023`*^9}, {
   3.8603952881392927`*^9, 3.8603953394026213`*^9}, {3.860395388202415*^9, 
   3.860395388656404*^9}, {3.860395441778183*^9, 3.860395480099478*^9}, {
   3.8603964035194473`*^9, 3.860396405031681*^9}, {3.860396570285593*^9, 
   3.86039657164571*^9}, {3.860400020803294*^9, 3.860400022686831*^9}, {
   3.860400090330511*^9, 3.8604000906263*^9}, {3.860428030633562*^9, 
   3.860428040081575*^9}, {3.86042930620494*^9, 3.860429413995893*^9}, {
   3.8604294618116207`*^9, 3.860429462650731*^9}, {3.860431503167091*^9, 
   3.860431515558955*^9}, {3.860690028999938*^9, 3.860690049247897*^9}, {
   3.86074418951239*^9, 3.860744191806445*^9}, {3.860772922885727*^9, 
   3.8607729257178717`*^9}, {3.860773012884869*^9, 3.86077303389275*^9}, {
   3.860961614453203*^9, 3.860961615444943*^9}, {3.860963077526119*^9, 
   3.860963086845869*^9}},ExpressionUUID->"e7328ef6-6ef5-448b-ac02-\
9556f9c7556d"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"AllTheories", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Combos", "[", 
    RowBox[{"conds_", ",", "combo_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"extraconds", ",", "extralabel"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"extraconds", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "&"}], "/@", "combo"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"extralabel", "=", 
       RowBox[{"StringJoin", "@", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"#", "[", 
            RowBox[{"[", "2", "]"}], "]"}], "&"}], "/@", "combo"}], ")"}]}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"conds", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "<>", "\"\<_\>\"", "<>", 
         "extralabel"}], ",", 
        RowBox[{
         RowBox[{"conds", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "~", "Join", "~", "extraconds"}]}], 
       "}"}]}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.860689653060398*^9, 3.8606896738540163`*^9}, {
   3.860689779537664*^9, 3.860689785705659*^9}, {3.860690060367118*^9, 
   3.860690097238505*^9}, {3.860690129798658*^9, 3.860690222645527*^9}, {
   3.860690580562024*^9, 3.860690624209668*^9}, {3.860690680328953*^9, 
   3.860690785199671*^9}, {3.8606908520075912`*^9, 3.86069087301521*^9}, {
   3.860690953793549*^9, 3.860691055885153*^9}, {3.860691138430894*^9, 
   3.860691178884083*^9}, {3.860691209549808*^9, 3.860691225260068*^9}, {
   3.8606912661749077`*^9, 3.860691282115073*^9}, {3.860691418876041*^9, 
   3.860691491580284*^9}, {3.860691684465639*^9, 3.860691748830594*^9}, {
   3.860691795288134*^9, 3.860691866070581*^9}, {3.860692647479925*^9, 
   3.8606926625027027`*^9}, {3.860692734628454*^9, 3.8606927400412607`*^9}, {
   3.8606927957014847`*^9, 3.860692797165125*^9}, {3.8606936492446938`*^9, 
   3.860693657542529*^9}, {3.860693724139948*^9, 3.860693727907587*^9}, {
   3.8607441807018642`*^9, 3.860744186966782*^9}, {3.860773053045192*^9, 
   3.860773055677383*^9}, {3.860777145445302*^9, 3.860777181891522*^9}, {
   3.8607773671746683`*^9, 3.860777380473637*^9}, {3.860777418033207*^9, 
   3.86077744534478*^9}, {3.860821974467496*^9, 3.860821982619364*^9}, {
   3.860822020626745*^9, 3.860822031242959*^9}, {3.8608220769948*^9, 
   3.860822081570167*^9}, {3.860823172743326*^9, 3.8608232608208103`*^9}, {
   3.860823306821208*^9, 3.860823307580269*^9}, {3.860823397324091*^9, 
   3.860823411267859*^9}, {3.860823453694626*^9, 3.860823456867881*^9}, {
   3.860823551954646*^9, 3.860823552106504*^9}, {3.860823930023685*^9, 
   3.86082404787641*^9}, {3.8608240788129807`*^9, 3.860824079149013*^9}, {
   3.860824131102036*^9, 3.8608241335576982`*^9}, {3.860824522033786*^9, 
   3.860824533608849*^9}, {3.860830207607524*^9, 3.860830295334888*^9}, {
   3.860832075443598*^9, 3.860832097717222*^9}, {3.860832634051939*^9, 
   3.860832673063992*^9}, {3.8608354752753963`*^9, 3.8608354924994164`*^9}, {
   3.8608355800098867`*^9, 3.8608356049126587`*^9}, 3.860837261069127*^9, {
   3.860961298063203*^9, 3.860961301985118*^9}, {3.860961620894299*^9, 
   3.860961621268957*^9}, {3.860962828843652*^9, 3.860962831187469*^9}, {
   3.860963090023019*^9, 3.860963097886758*^9}, {3.861198777712636*^9, 
   3.8611987924809303`*^9}, {3.8618707047169857`*^9, 3.861870705837042*^9}, {
   3.862041702848177*^9, 3.8620417030025597`*^9}, {3.8620417775356083`*^9, 
   3.8620418508051157`*^9}, {3.8620419750994463`*^9, 3.862042061060047*^9}, {
   3.862053428336557*^9, 
   3.86205343509676*^9}},ExpressionUUID->"c01d7981-e125-4af4-abe3-\
cbc57af5a91d"],

Cell["\<\
Selective choice of multipliers so as not to interfere with the active \
sectors.\
\>", "Text",
 CellChangeTimes->{{3.8620534972378187`*^9, 
  3.862053513302719*^9}},ExpressionUUID->"648c8900-cff7-4c84-bce0-\
9a3024800ef9"],

Cell[BoxData[
 RowBox[{"(*", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Switches", "=", 
    RowBox[{"Subsets", "@", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cAlp3", "\[Equal]", "0"}], ",", "\"\<A3\>\""}], "}"}], ",", 
       
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cAlp4", "\[Equal]", "0"}], ",", "\"\<A4\>\""}], "}"}], ",", 
       
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cAlp6", "\[Equal]", "0"}], ",", "\"\<A6\>\""}], "}"}], ",", 
       
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cBet1", "\[Equal]", "0"}], ",", "\"\<B1\>\""}], "}"}], ",", 
       
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cBet2", "\[Equal]", "0"}], ",", "\"\<B2\>\""}], "}"}], ",", 
       
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cBet3", "\[Equal]", "0"}], ",", "\"\<B3\>\""}], "}"}]}], 
      "}"}]}]}], ";", "\[IndentingNewLine]", 
   RowBox[{"C1", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"Combos", "[", 
       RowBox[{
        RowBox[{"RawJobsBatch", "[", 
         RowBox[{"[", "3", "]"}], "]"}], ",", "#"}], "]"}], "&"}], "/@", 
     "Switches"}]}], ";", "\[IndentingNewLine]", 
   RowBox[{"Switches", "=", 
    RowBox[{"Subsets", "@", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cAlp3", "\[Equal]", "0"}], ",", "\"\<A3\>\""}], "}"}], ",", 
       
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cAlp6", "\[Equal]", "0"}], ",", "\"\<A6\>\""}], "}"}], ",", 
       
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cBet1", "\[Equal]", "0"}], ",", "\"\<B1\>\""}], "}"}], ",", 
       
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cBet2", "\[Equal]", "0"}], ",", "\"\<B2\>\""}], "}"}], ",", 
       
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cBet3", "\[Equal]", "0"}], ",", "\"\<B3\>\""}], "}"}]}], 
      "}"}]}]}], ";", "\[IndentingNewLine]", 
   RowBox[{"C2", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"Combos", "[", 
       RowBox[{
        RowBox[{"RawJobsBatch", "[", 
         RowBox[{"[", "4", "]"}], "]"}], ",", "#"}], "]"}], "&"}], "/@", 
     "Switches"}]}], ";", "\[IndentingNewLine]", 
   RowBox[{"Switches", "=", 
    RowBox[{"Subsets", "@", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cAlp3", "\[Equal]", "0"}], ",", "\"\<A3\>\""}], "}"}], ",", 
       
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cAlp5", "\[Equal]", "0"}], ",", "\"\<A5\>\""}], "}"}], ",", 
       
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cAlp6", "\[Equal]", "0"}], ",", "\"\<A6\>\""}], "}"}], ",", 
       
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cBet1", "\[Equal]", "0"}], ",", "\"\<B1\>\""}], "}"}], ",", 
       
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cBet2", "\[Equal]", "0"}], ",", "\"\<B2\>\""}], "}"}], ",", 
       
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cBet3", "\[Equal]", "0"}], ",", "\"\<B3\>\""}], "}"}]}], 
      "}"}]}]}], ";", "\[IndentingNewLine]", 
   RowBox[{"C3", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"Combos", "[", 
       RowBox[{
        RowBox[{"RawJobsBatch", "[", 
         RowBox[{"[", "5", "]"}], "]"}], ",", "#"}], "]"}], "&"}], "/@", 
     "Switches"}]}], ";"}], "\[IndentingNewLine]", "*)"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.860689653060398*^9, 3.8606896738540163`*^9}, {
   3.860689779537664*^9, 3.860689785705659*^9}, {3.860690060367118*^9, 
   3.860690097238505*^9}, {3.860690129798658*^9, 3.860690222645527*^9}, {
   3.860690580562024*^9, 3.860690624209668*^9}, {3.860690680328953*^9, 
   3.860690785199671*^9}, {3.8606908520075912`*^9, 3.86069087301521*^9}, {
   3.860690953793549*^9, 3.860691055885153*^9}, {3.860691138430894*^9, 
   3.860691178884083*^9}, {3.860691209549808*^9, 3.860691225260068*^9}, {
   3.8606912661749077`*^9, 3.860691282115073*^9}, {3.860691418876041*^9, 
   3.860691491580284*^9}, {3.860691684465639*^9, 3.860691748830594*^9}, {
   3.860691795288134*^9, 3.860691866070581*^9}, {3.860692647479925*^9, 
   3.8606926625027027`*^9}, {3.860692734628454*^9, 3.8606927400412607`*^9}, {
   3.8606927957014847`*^9, 3.860692797165125*^9}, {3.8606936492446938`*^9, 
   3.860693657542529*^9}, {3.860693724139948*^9, 3.860693727907587*^9}, {
   3.8607441807018642`*^9, 3.860744186966782*^9}, {3.860773053045192*^9, 
   3.860773055677383*^9}, {3.860777145445302*^9, 3.860777181891522*^9}, {
   3.8607773671746683`*^9, 3.860777380473637*^9}, {3.860777418033207*^9, 
   3.86077744534478*^9}, {3.860821974467496*^9, 3.860821982619364*^9}, {
   3.860822020626745*^9, 3.860822031242959*^9}, {3.8608220769948*^9, 
   3.860822081570167*^9}, {3.860823172743326*^9, 3.8608232608208103`*^9}, {
   3.860823306821208*^9, 3.860823307580269*^9}, {3.860823397324091*^9, 
   3.860823411267859*^9}, {3.860823453694626*^9, 3.860823456867881*^9}, {
   3.860823551954646*^9, 3.860823552106504*^9}, {3.860823930023685*^9, 
   3.86082404787641*^9}, {3.8608240788129807`*^9, 3.860824079149013*^9}, {
   3.860824131102036*^9, 3.8608241335576982`*^9}, {3.860824522033786*^9, 
   3.860824533608849*^9}, {3.860830207607524*^9, 3.860830295334888*^9}, {
   3.860832075443598*^9, 3.860832097717222*^9}, {3.860832634051939*^9, 
   3.860832673063992*^9}, {3.8608354752753963`*^9, 3.8608354924994164`*^9}, {
   3.8608355800098867`*^9, 3.8608356049126587`*^9}, 3.860837261069127*^9, {
   3.860961298063203*^9, 3.860961301985118*^9}, {3.860961620894299*^9, 
   3.860961621268957*^9}, {3.860962828843652*^9, 3.860962831187469*^9}, {
   3.860963090023019*^9, 3.860963097886758*^9}, {3.861198777712636*^9, 
   3.8611987924809303`*^9}, {3.8618707047169857`*^9, 3.861870705837042*^9}, {
   3.862041702848177*^9, 3.8620417030025597`*^9}, {3.8620417775356083`*^9, 
   3.8620418508051157`*^9}, {3.8620419750994463`*^9, 3.862042061060047*^9}, {
   3.862053428336557*^9, 3.862053437729443*^9}, {3.862053484127143*^9, 
   3.8620534880572147`*^9}},ExpressionUUID->"05b577b9-54c0-4e71-b5bc-\
6a919093819b"],

Cell["Brute-force choice of multipliers.", "Text",
 CellChangeTimes->{{3.8620535177100363`*^9, 
  3.8620535264467373`*^9}},ExpressionUUID->"6b677ffa-4d4c-4bdb-bdc8-\
3199f382d3fd"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Switches", "=", 
   RowBox[{"Subsets", "@", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cAlp3", "\[Equal]", "0"}], ",", "\"\<A3\>\""}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cAlp4", "\[Equal]", "0"}], ",", "\"\<A4\>\""}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cAlp6", "\[Equal]", "0"}], ",", "\"\<A6\>\""}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cBet1", "\[Equal]", "0"}], ",", "\"\<B1\>\""}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cBet2", "\[Equal]", "0"}], ",", "\"\<B2\>\""}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cBet3", "\[Equal]", "0"}], ",", "\"\<B3\>\""}], "}"}]}], 
     "}"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"C1", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Combos", "[", 
      RowBox[{
       RowBox[{"RawJobsBatch", "[", 
        RowBox[{"[", "6", "]"}], "]"}], ",", "#"}], "]"}], "&"}], "/@", 
    "Switches"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Switches", "=", 
   RowBox[{"Subsets", "@", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cAlp2", "\[Equal]", "0"}], ",", "\"\<A2\>\""}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cAlp3", "\[Equal]", "0"}], ",", "\"\<A3\>\""}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cAlp6", "\[Equal]", "0"}], ",", "\"\<A6\>\""}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cBet1", "\[Equal]", "0"}], ",", "\"\<B1\>\""}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cBet2", "\[Equal]", "0"}], ",", "\"\<B2\>\""}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cBet3", "\[Equal]", "0"}], ",", "\"\<B3\>\""}], "}"}]}], 
     "}"}]}]}], ";", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"trying", " ", 
      RowBox[{"A2", " ", "--"}]}], "-", " ", 
     RowBox[{"VERY", " ", "HEAVY"}]}], ",", " ", 
    RowBox[{
     RowBox[{"but", " ", "posibly", " ", "do"}], "-", "able"}]}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"C2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Combos", "[", 
      RowBox[{
       RowBox[{"RawJobsBatch", "[", 
        RowBox[{"[", "7", "]"}], "]"}], ",", "#"}], "]"}], "&"}], "/@", 
    "Switches"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Switches", "=", 
   RowBox[{"Subsets", "@", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cAlp3", "\[Equal]", "0"}], ",", "\"\<A3\>\""}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cAlp5", "\[Equal]", "0"}], ",", "\"\<A5\>\""}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cAlp6", "\[Equal]", "0"}], ",", "\"\<A6\>\""}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cBet1", "\[Equal]", "0"}], ",", "\"\<B1\>\""}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cBet2", "\[Equal]", "0"}], ",", "\"\<B2\>\""}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"cBet3", "\[Equal]", "0"}], ",", "\"\<B3\>\""}], "}"}]}], 
     "}"}]}]}], ";", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"don", "'"}], "t", " ", "add", " ", "A4"}], "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"C3", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Combos", "[", 
      RowBox[{
       RowBox[{"RawJobsBatch", "[", 
        RowBox[{"[", "8", "]"}], "]"}], ",", "#"}], "]"}], "&"}], "/@", 
    "Switches"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.860689653060398*^9, 3.8606896738540163`*^9}, {
   3.860689779537664*^9, 3.860689785705659*^9}, {3.860690060367118*^9, 
   3.860690097238505*^9}, {3.860690129798658*^9, 3.860690222645527*^9}, {
   3.860690580562024*^9, 3.860690624209668*^9}, {3.860690680328953*^9, 
   3.860690785199671*^9}, {3.8606908520075912`*^9, 3.86069087301521*^9}, {
   3.860690953793549*^9, 3.860691055885153*^9}, {3.860691138430894*^9, 
   3.860691178884083*^9}, {3.860691209549808*^9, 3.860691225260068*^9}, {
   3.8606912661749077`*^9, 3.860691282115073*^9}, {3.860691418876041*^9, 
   3.860691491580284*^9}, {3.860691684465639*^9, 3.860691748830594*^9}, {
   3.860691795288134*^9, 3.860691866070581*^9}, {3.860692647479925*^9, 
   3.8606926625027027`*^9}, {3.860692734628454*^9, 3.8606927400412607`*^9}, {
   3.8606927957014847`*^9, 3.860692797165125*^9}, {3.8606936492446938`*^9, 
   3.860693657542529*^9}, {3.860693724139948*^9, 3.860693727907587*^9}, {
   3.8607441807018642`*^9, 3.860744186966782*^9}, {3.860773053045192*^9, 
   3.860773055677383*^9}, {3.860777145445302*^9, 3.860777181891522*^9}, {
   3.8607773671746683`*^9, 3.860777380473637*^9}, {3.860777418033207*^9, 
   3.86077744534478*^9}, {3.860821974467496*^9, 3.860821982619364*^9}, {
   3.860822020626745*^9, 3.860822031242959*^9}, {3.8608220769948*^9, 
   3.860822081570167*^9}, {3.860823172743326*^9, 3.8608232608208103`*^9}, {
   3.860823306821208*^9, 3.860823307580269*^9}, {3.860823397324091*^9, 
   3.860823411267859*^9}, {3.860823453694626*^9, 3.860823456867881*^9}, {
   3.860823551954646*^9, 3.860823552106504*^9}, {3.860823930023685*^9, 
   3.86082404787641*^9}, {3.8608240788129807`*^9, 3.860824079149013*^9}, {
   3.860824131102036*^9, 3.8608241335576982`*^9}, {3.860824522033786*^9, 
   3.860824533608849*^9}, {3.860830207607524*^9, 3.860830295334888*^9}, {
   3.860832075443598*^9, 3.860832097717222*^9}, {3.860832634051939*^9, 
   3.860832673063992*^9}, {3.8608354752753963`*^9, 3.8608354924994164`*^9}, {
   3.8608355800098867`*^9, 3.8608356049126587`*^9}, 3.860837261069127*^9, {
   3.860961298063203*^9, 3.860961301985118*^9}, {3.860961620894299*^9, 
   3.860961621268957*^9}, {3.860962828843652*^9, 3.860962831187469*^9}, {
   3.860963090023019*^9, 3.860963097886758*^9}, {3.861198777712636*^9, 
   3.8611987924809303`*^9}, {3.8618707047169857`*^9, 3.861870705837042*^9}, {
   3.862041702848177*^9, 3.8620417030025597`*^9}, {3.8620417775356083`*^9, 
   3.8620418508051157`*^9}, {3.8620419750994463`*^9, 3.862042061060047*^9}, {
   3.862053428336557*^9, 3.862053475814945*^9}, {3.862053952778283*^9, 
   3.862053976507285*^9}, 3.8620590283914948`*^9, 3.8620620211862164`*^9, 
   3.862065894875103*^9, 3.862077410047164*^9, 3.862118528242516*^9, {
   3.8621246307011147`*^9, 3.862124650076247*^9}, 3.862124851227956*^9, {
   3.8621297904771214`*^9, 3.862129794700326*^9}, {3.8621365383637743`*^9, 
   3.8621365709956713`*^9}, {3.862136766196124*^9, 3.862136770066228*^9}, {
   3.862309401883967*^9, 3.862309411434307*^9}, {3.8624147174724417`*^9, 
   3.862414733760867*^9}, {3.8624636140601683`*^9, 
   3.86246361612514*^9}},ExpressionUUID->"c0a2ad95-eb1b-485e-928b-\
017df7a3b150"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "*)"}], 
  RowBox[{
   RowBox[{
    RowBox[{"AllTheories", "=", 
     RowBox[{"Join", "[", 
      RowBox[{"C1", ",", "C2", ",", "C3"}], "]"}]}], ";", 
    RowBox[{"(*", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"AllTheories", "=", "C1"}], ";"}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"(*", "*)"}], 
    RowBox[{"AllTheories", "=", 
     RowBox[{"RandomSample", "@", "AllTheories"}]}], ";", 
    RowBox[{"(*", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"AllTheories", "=", 
       RowBox[{"Reverse", "@", 
        RowBox[{"(", 
         RowBox[{"AllTheories", "~", "SortBy", "~", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"Length", "@", 
              RowBox[{"Flatten", "@", "#"}]}], ")"}], "&"}], ")"}]}], 
         ")"}]}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
    RowBox[{"Print", "[", 
     RowBox[{"Length", "@", "AllTheories"}], "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"st", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "}"}], ",", 
       RowBox[{"{", "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", "1"}], ",", 
      RowBox[{"i", "<", 
       RowBox[{
        RowBox[{"Length", "@", "AllTheories"}], "+", "1"}]}], ",", 
      RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"index", "=", 
        RowBox[{
         RowBox[{"i", "~", "Mod", "~", "14"}], "+", "1"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Print", "@", "index"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Print", "@", 
        RowBox[{"st", "[", 
         RowBox[{"[", "index", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"st", "[", 
         RowBox[{"[", "index", "]"}], "]"}], "=", 
        RowBox[{
         RowBox[{"st", "[", 
          RowBox[{"[", "index", "]"}], "]"}], "~", "Append", "~", 
         RowBox[{"AllTheories", "[", 
          RowBox[{"[", "i", "]"}], "]"}]}]}], ";"}]}], "\[IndentingNewLine]", 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"AllTheories", "=", "st"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"i", "=", "1"}], ",", 
      RowBox[{"i", "<", "15"}], ",", 
      RowBox[{"i", "++"}], ",", 
      RowBox[{
       RowBox[{"Print", "[", 
        RowBox[{"\"\<Node number \>\"", ",", 
         RowBox[{"i", "-", "1"}], ",", "\"\< is allocated a batch of \>\"", 
         ",", 
         RowBox[{"Length", "@", 
          RowBox[{"AllTheories", "[", 
           RowBox[{"[", "i", "]"}], "]"}]}], ",", "\"\< theories.\>\""}], 
        "]"}], ";"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"For", "[", 
     RowBox[{
      RowBox[{"node", "=", "0"}], ",", 
      RowBox[{"node", "<", 
       RowBox[{"Length", "@", "AllTheories"}]}], ",", 
      RowBox[{"node", "++"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"JobsBatch", "=", 
        RowBox[{"AllTheories", "[", 
         RowBox[{"[", 
          RowBox[{"node", "+", "1"}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Run", "@", 
        RowBox[{"(", 
         RowBox[{"\"\<mkdir ./svy/node-\>\"", "<>", 
          RowBox[{"ToString", "@", "node"}]}], ")"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Run", "@", 
        RowBox[{"(", 
         RowBox[{"\"\<mkdir ./svy/node-\>\"", "<>", 
          RowBox[{"ToString", "@", "node"}], "<>", "\"\</chr\>\""}], ")"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"FileNameJoin", "@", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Directory", "[", "]"}], ",", 
           RowBox[{"\"\<svy/node-\>\"", "<>", 
            RowBox[{"ToString", "@", "node"}]}], ",", 
           "\"\<peta4.svy.mx\>\""}], "}"}]}], "~", "DumpSave", "~", 
        RowBox[{"{", "JobsBatch", "}"}]}], ";"}]}], "\[IndentingNewLine]", 
     "]"}], ";"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.860689653060398*^9, 3.8606896738540163`*^9}, {
   3.860689779537664*^9, 3.860689785705659*^9}, {3.860690060367118*^9, 
   3.860690097238505*^9}, {3.860690129798658*^9, 3.860690222645527*^9}, {
   3.860690580562024*^9, 3.860690624209668*^9}, {3.860690680328953*^9, 
   3.860690785199671*^9}, {3.8606908520075912`*^9, 3.86069087301521*^9}, {
   3.860690953793549*^9, 3.860691055885153*^9}, {3.860691138430894*^9, 
   3.860691178884083*^9}, {3.860691209549808*^9, 3.860691225260068*^9}, {
   3.8606912661749077`*^9, 3.860691282115073*^9}, {3.860691418876041*^9, 
   3.860691491580284*^9}, {3.860691684465639*^9, 3.860691748830594*^9}, {
   3.860691795288134*^9, 3.860691866070581*^9}, {3.860692647479925*^9, 
   3.8606926625027027`*^9}, {3.860692734628454*^9, 3.8606927400412607`*^9}, {
   3.8606927957014847`*^9, 3.860692797165125*^9}, {3.8606936492446938`*^9, 
   3.860693657542529*^9}, {3.860693724139948*^9, 3.860693727907587*^9}, {
   3.8607441807018642`*^9, 3.860744186966782*^9}, {3.860773053045192*^9, 
   3.860773055677383*^9}, {3.860777145445302*^9, 3.860777181891522*^9}, {
   3.8607773671746683`*^9, 3.860777380473637*^9}, {3.860777418033207*^9, 
   3.86077744534478*^9}, {3.860821974467496*^9, 3.860821982619364*^9}, {
   3.860822020626745*^9, 3.860822031242959*^9}, {3.8608220769948*^9, 
   3.860822081570167*^9}, {3.860823172743326*^9, 3.8608232608208103`*^9}, {
   3.860823306821208*^9, 3.860823307580269*^9}, {3.860823397324091*^9, 
   3.860823411267859*^9}, {3.860823453694626*^9, 3.860823456867881*^9}, {
   3.860823551954646*^9, 3.860823552106504*^9}, {3.860823930023685*^9, 
   3.86082404787641*^9}, {3.8608240788129807`*^9, 3.860824079149013*^9}, {
   3.860824131102036*^9, 3.8608241335576982`*^9}, {3.860824522033786*^9, 
   3.860824533608849*^9}, {3.860830207607524*^9, 3.860830295334888*^9}, {
   3.860832075443598*^9, 3.860832097717222*^9}, {3.860832634051939*^9, 
   3.860832673063992*^9}, {3.8608354752753963`*^9, 3.8608354924994164`*^9}, {
   3.8608355800098867`*^9, 3.8608356049126587`*^9}, 3.860837261069127*^9, {
   3.860961298063203*^9, 3.860961301985118*^9}, {3.860961620894299*^9, 
   3.860961621268957*^9}, {3.860962828843652*^9, 3.860962831187469*^9}, {
   3.860963090023019*^9, 3.860963097886758*^9}, {3.861198777712636*^9, 
   3.8611987924809303`*^9}, {3.8618707047169857`*^9, 3.861870705837042*^9}, {
   3.862041702848177*^9, 3.8620417030025597`*^9}, {3.8620417775356083`*^9, 
   3.8620418508051157`*^9}, {3.8620419750994463`*^9, 3.862042061060047*^9}, {
   3.862053428336557*^9, 3.86205344070448*^9}, {3.8624147826228333`*^9, 
   3.862414792399225*^9}, {3.862463646444865*^9, 
   3.862463654643414*^9}},ExpressionUUID->"9fff71ad-812a-4932-bbfb-\
1ff310584aef"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Quit", "[", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.8561134940016623`*^9, 3.856113563953445*^9}, {
   3.856113864152964*^9, 3.856113866735909*^9}, {3.856114686146227*^9, 
   3.856114722201364*^9}, {3.8561147534818153`*^9, 3.856114786785334*^9}, {
   3.8561150379530697`*^9, 3.8561150382066393`*^9}, {3.856115132575592*^9, 
   3.856115149455024*^9}, 3.856165332453063*^9, {3.856165412953887*^9, 
   3.856165493969346*^9}, {3.856165882551499*^9, 3.8561659681267014`*^9}, {
   3.856252550417321*^9, 3.856252550671973*^9}, {3.856253384785056*^9, 
   3.856253537238635*^9}, {3.856253871827731*^9, 3.856253912977112*^9}, {
   3.856266135351696*^9, 3.85626613949498*^9}, {3.856330112716134*^9, 
   3.856330148356846*^9}, {3.856334077806583*^9, 3.85633412540273*^9}, {
   3.8563374211690483`*^9, 3.8563375146333323`*^9}, {3.8563713031675777`*^9, 
   3.8563713066542683`*^9}, {3.856407380427725*^9, 3.856407391803412*^9}, {
   3.856407608764429*^9, 3.8564076196720247`*^9}, 3.856407752091467*^9, 
   3.856407826016653*^9, 3.856407902750139*^9, {3.85640794860667*^9, 
   3.8564079506166077`*^9}, {3.8564080331074467`*^9, 3.856408035278562*^9}, 
   3.856408749583098*^9, {3.8564088204491577`*^9, 3.856408851243552*^9}, {
   3.856408937610999*^9, 3.856408958571206*^9}, 3.856426594371249*^9, {
   3.856546771934794*^9, 3.856546780533009*^9}, {3.856547050566327*^9, 
   3.856547182411356*^9}, {3.8565472180334578`*^9, 3.8565472297545033`*^9}, {
   3.856547261019403*^9, 3.856547319535778*^9}, {3.856547389634677*^9, 
   3.856547415811049*^9}, {3.856547502452675*^9, 3.8565475402935333`*^9}, {
   3.856547935615954*^9, 3.856547996958641*^9}, {3.8565480427427683`*^9, 
   3.856548130126974*^9}, {3.856548174271737*^9, 3.856548238495077*^9}, {
   3.856548994305244*^9, 3.856549018994968*^9}, {3.856549639533609*^9, 
   3.856549677197238*^9}, {3.856550750202263*^9, 3.856550754237236*^9}, {
   3.856584484801955*^9, 3.856584543913227*^9}, {3.856584817941999*^9, 
   3.856584869979888*^9}, 3.856585073668594*^9, {3.85658620385732*^9, 
   3.856586205956044*^9}, {3.856588920521818*^9, 3.856588921557769*^9}, 
   3.856588960476514*^9, {3.856590039993527*^9, 3.85659006622727*^9}, {
   3.856593936282866*^9, 3.856593948507574*^9}, {3.856593995428607*^9, 
   3.856593999792821*^9}, {3.856594042031241*^9, 3.856594053246723*^9}, {
   3.856594086439999*^9, 3.856594226084935*^9}, {3.85659432821384*^9, 
   3.856594469940914*^9}, {3.856594500282078*^9, 3.856594544618071*^9}, {
   3.856594612259853*^9, 3.856594769070032*^9}, {3.856594873905396*^9, 
   3.856594956693438*^9}, {3.8565950194680347`*^9, 3.856595074756282*^9}, {
   3.856595284751771*^9, 3.856595285285953*^9}, {3.856595383481922*^9, 
   3.856595426680007*^9}, {3.856596034870791*^9, 3.8565960350298347`*^9}, {
   3.85659607209651*^9, 3.85659608586699*^9}, {3.8565965701300287`*^9, 
   3.856596638947892*^9}, {3.856596725375925*^9, 3.856596731990838*^9}, {
   3.856598251369217*^9, 3.856598258241246*^9}, {3.856598434570442*^9, 
   3.856598462529182*^9}, {3.85659873835382*^9, 3.85659873866574*^9}, 
   3.856598824236*^9, {3.856598867332992*^9, 3.856598962700162*^9}, {
   3.8565990452773323`*^9, 3.856599068467422*^9}, {3.8565991551085377`*^9, 
   3.8565993229007053`*^9}, {3.8565993536914263`*^9, 3.856599417248561*^9}, {
   3.856600138751534*^9, 3.8566001661422253`*^9}, {3.8566002060986834`*^9, 
   3.856600225334676*^9}, {3.856600544026388*^9, 3.8566005441484118`*^9}, {
   3.856600586409638*^9, 3.856600612088909*^9}, {3.856600663947249*^9, 
   3.856600689908874*^9}, {3.856600745930562*^9, 3.8566008026048613`*^9}, {
   3.8566010638589973`*^9, 3.856601092986932*^9}, {3.85660138015917*^9, 
   3.8566013877983093`*^9}, {3.856606601818824*^9, 3.856606632750181*^9}, {
   3.856606721016076*^9, 3.856606801080719*^9}, {3.856607075354292*^9, 
   3.8566070793089247`*^9}, {3.856607285519328*^9, 3.856607350667756*^9}, {
   3.8566074599074087`*^9, 3.85660763592397*^9}, {3.856615179405943*^9, 
   3.856615210040922*^9}, {3.856630195894566*^9, 3.856630253259329*^9}, {
   3.8566931344471893`*^9, 3.856693204813795*^9}, 3.856693305118594*^9, {
   3.856693563355632*^9, 3.856693567190674*^9}, {3.856693669447075*^9, 
   3.8566936779144287`*^9}, {3.8566938062708397`*^9, 3.856693808318098*^9}, {
   3.8566939398466473`*^9, 3.856693942230942*^9}, {3.856697869620206*^9, 
   3.856697873773686*^9}, {3.856698360189404*^9, 3.856698371872653*^9}, {
   3.856700875553402*^9, 3.8567008771913757`*^9}, {3.8567019896412363`*^9, 
   3.856701992163899*^9}, {3.856702058555892*^9, 3.856702093022097*^9}, {
   3.8567024693164377`*^9, 3.856702472672245*^9}, {3.856702662221097*^9, 
   3.8567026639724407`*^9}, {3.856702933353261*^9, 3.856702937571703*^9}, {
   3.856702969037169*^9, 3.8567029816901608`*^9}, {3.856703272825307*^9, 
   3.8567032770478907`*^9}, {3.856703434516992*^9, 3.856703449079845*^9}, {
   3.856703764231814*^9, 3.856703769679906*^9}, {3.85670523350788*^9, 
   3.856705255121399*^9}, {3.856705300802005*^9, 3.8567053440432377`*^9}, 
   3.8567053835308113`*^9, {3.856716776053294*^9, 3.856716798617839*^9}, {
   3.856717296675805*^9, 3.856717300454899*^9}, {3.856717455235383*^9, 
   3.856717459302205*^9}, {3.856717558228253*^9, 3.856717577490952*^9}, {
   3.856766079861846*^9, 3.856766199328062*^9}, {3.856768657046853*^9, 
   3.856768658811205*^9}, {3.856768689609551*^9, 3.8567687186879473`*^9}, {
   3.856847824059163*^9, 3.856847829756719*^9}, {3.856885056781955*^9, 
   3.8568850572425117`*^9}, {3.8568875962693453`*^9, 3.856887605235325*^9}, {
   3.8569364364172297`*^9, 3.856936438322406*^9}, {3.8569572256026897`*^9, 
   3.856957232048373*^9}, {3.858142966335279*^9, 3.858142967860476*^9}, {
   3.85818112692178*^9, 3.8581811377360287`*^9}, {3.858181271677498*^9, 
   3.8581812782539043`*^9}, 3.858181354071229*^9, {3.858181524199338*^9, 
   3.858181555061183*^9}, 3.858181602086733*^9, {3.858181671389921*^9, 
   3.858181758453566*^9}, {3.858181924587641*^9, 3.858181926451866*^9}, {
   3.858181962742115*^9, 3.858181972902639*^9}, {3.8581820085582523`*^9, 
   3.8581820428319693`*^9}, {3.858182313602854*^9, 3.858182318711783*^9}, 
   3.858182736132729*^9, {3.858182873156907*^9, 3.858182876713172*^9}, {
   3.858184058358448*^9, 3.858184060194497*^9}, {3.858184214826552*^9, 
   3.8581842270070047`*^9}, {3.858184821147771*^9, 3.858184822231308*^9}, {
   3.8581858194322453`*^9, 3.85818582401626*^9}, {3.8582267013467503`*^9, 
   3.8582267055196037`*^9}, 3.858228301091529*^9, {3.858229492565473*^9, 
   3.8582295062000647`*^9}, {3.8582296669434967`*^9, 
   3.8582297318074417`*^9}, {3.8582301400178213`*^9, 
   3.8582301519399233`*^9}, {3.8582307301490602`*^9, 3.858230772531424*^9}, {
   3.858231510513658*^9, 3.858231523827112*^9}, {3.858233464638513*^9, 
   3.8582334712864532`*^9}, {3.8582336759973717`*^9, 
   3.8582336788817043`*^9}, {3.8582343296727877`*^9, 3.858234401096449*^9}, 
   3.858234510434876*^9, {3.858235066237193*^9, 3.8582350738367023`*^9}, {
   3.858235202140679*^9, 3.858235220235373*^9}, {3.858235454699109*^9, 
   3.858235467892789*^9}, {3.858236200960024*^9, 3.858236217929487*^9}, {
   3.858236832559057*^9, 3.858236840867004*^9}, {3.858238575009941*^9, 
   3.85823861822012*^9}, {3.8582393686107492`*^9, 3.8582393946451683`*^9}, {
   3.858239531711216*^9, 3.858239538715068*^9}, {3.8582397821401167`*^9, 
   3.858239782385582*^9}, {3.858243501836114*^9, 3.858243533066533*^9}, 
   3.8582517677726316`*^9, {3.858253141465578*^9, 3.858253156004655*^9}, {
   3.858262523424046*^9, 3.8582625263262672`*^9}, {3.8582626132154093`*^9, 
   3.858262651990097*^9}, {3.858263093996423*^9, 3.858263107363203*^9}, {
   3.858269621613408*^9, 3.8582696456949043`*^9}, {3.858270163378757*^9, 
   3.858270173825705*^9}, {3.8582710242137823`*^9, 3.858271030036566*^9}, {
   3.858339575377823*^9, 3.858339606721662*^9}, {3.858342927878196*^9, 
   3.8583429658853207`*^9}, {3.858433836920229*^9, 3.8584338580792007`*^9}, {
   3.858444408381193*^9, 3.858444410492931*^9}, {3.858488493308608*^9, 
   3.858488497917211*^9}, {3.858488536588729*^9, 3.8584885507801733`*^9}, {
   3.858489530903399*^9, 3.858489533822534*^9}, {3.858490078702059*^9, 
   3.858490081194944*^9}, {3.8584935454650297`*^9, 3.858493546463683*^9}, {
   3.858493586904846*^9, 3.8584936478150787`*^9}, {3.858495601141667*^9, 
   3.858495607299471*^9}, {3.858496325240609*^9, 3.858496327438936*^9}, 
   3.858497286249983*^9, {3.858498767025363*^9, 3.858498795672372*^9}, {
   3.858499119271175*^9, 3.8584991240866756`*^9}, {3.858510475487196*^9, 
   3.8585104773659773`*^9}, {3.858510663777513*^9, 3.8585107203833313`*^9}, {
   3.858510766166922*^9, 3.858510819231451*^9}, {3.858514732542738*^9, 
   3.858514775339328*^9}, {3.858524787588656*^9, 3.858524805815624*^9}, {
   3.858586280769*^9, 3.858586320902526*^9}, {3.8586041766885843`*^9, 
   3.858604235656663*^9}, {3.858604268024601*^9, 3.8586043932366858`*^9}, {
   3.8586756463415127`*^9, 3.858675658869523*^9}, {3.858693513549828*^9, 
   3.858693520322974*^9}, {3.858707622178495*^9, 3.858707625882985*^9}, {
   3.858713068848999*^9, 3.858713111616528*^9}, {3.8587397670160303`*^9, 
   3.85873976882025*^9}, {3.8587675401932583`*^9, 3.858767541652359*^9}, {
   3.858832057428598*^9, 3.858832057926138*^9}, {3.858837232206874*^9, 
   3.858837233645618*^9}, {3.858853493013969*^9, 3.8588535088894873`*^9}, 
   3.858855124164269*^9, {3.8588564226327744`*^9, 3.858856431548901*^9}, 
   3.8589136332742987`*^9, 3.858919114696944*^9, 3.85893209743512*^9, 
   3.858945274840987*^9, {3.858952938922271*^9, 3.858952942944778*^9}, 
   3.8589531113849363`*^9, 3.858995404369176*^9, {3.8589956417225437`*^9, 
   3.858995644914462*^9}, {3.8590358762954283`*^9, 3.85903590700359*^9}, {
   3.859091432673786*^9, 3.8590914661578608`*^9}, 3.859117315940999*^9, 
   3.859146655027433*^9, {3.859172984765532*^9, 3.859172993171767*^9}, {
   3.8592159531931887`*^9, 3.859215953986575*^9}, {3.859617013949033*^9, 
   3.8596170867982264`*^9}, {3.85970281276968*^9, 3.85970281470197*^9}, {
   3.859742016589634*^9, 3.8597420216673613`*^9}, {3.8597835044637527`*^9, 
   3.8597835199839087`*^9}, {3.8597911002859983`*^9, 3.859791100724319*^9}, 
   3.860040870391541*^9, 3.860044767183367*^9, {3.8600501884979267`*^9, 
   3.860050190728992*^9}, {3.860050222695786*^9, 3.860050240304451*^9}, {
   3.860051976431161*^9, 3.860051976698119*^9}, {3.86007842241339*^9, 
   3.860078422741357*^9}, {3.86007958297482*^9, 3.860079589892458*^9}, {
   3.860254795985964*^9, 3.860254796273282*^9}, {3.8603905581247187`*^9, 
   3.86039056046061*^9}, {3.860392391857956*^9, 3.860392410433288*^9}, {
   3.860392737542636*^9, 3.860392743422007*^9}, 3.8603945110445967`*^9, {
   3.8603946230506077`*^9, 3.860394676904513*^9}, {3.860394826113806*^9, 
   3.86039485469093*^9}, {3.860395042709858*^9, 3.8603951368367023`*^9}, {
   3.8603952881392927`*^9, 3.8603953394026213`*^9}, {3.860395388202415*^9, 
   3.860395388656404*^9}, {3.860395441778183*^9, 3.860395480099478*^9}},
 CellLabel->"In[8]:=",ExpressionUUID->"e538eff8-6b5e-429d-8880-74d9dd7cafd3"]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1920, 1147},
WindowMargins->{{Automatic, 1080}, {Automatic, 53}},
TaggingRules->Association["TryRealOnly" -> False],
FrontEndVersion->"11.3 for Linux x86 (64-bit) (March 6, 2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 329, 8, 99, "Title",ExpressionUUID->"77b3805d-060b-4070-8508-41576cdf0004"],
Cell[912, 32, 411, 8, 36, "Text",ExpressionUUID->"ac3b952a-323b-405e-9ac1-f072cdc53b32"],
Cell[1326, 42, 568, 10, 94, "Input",ExpressionUUID->"68ab92ad-3c68-4108-8669-f32b9f7a052f",
 InitializationCell->True],
Cell[1897, 54, 18244, 316, 255, "Input",ExpressionUUID->"e2c58913-e1e8-4976-9444-297f506ffb31",
 InitializationCell->True],
Cell[20144, 372, 13760, 214, 255, "Input",ExpressionUUID->"e7328ef6-6ef5-448b-ac02-9556f9c7556d",
 InitializationCell->True],
Cell[33907, 588, 3855, 75, 140, "Input",ExpressionUUID->"c01d7981-e125-4af4-abe3-cbc57af5a91d",
 InitializationCell->True],
Cell[37765, 665, 233, 6, 36, "Text",ExpressionUUID->"648c8900-cff7-4c84-bce0-9a3024800ef9"],
Cell[38001, 673, 6061, 144, 209, "Input",ExpressionUUID->"05b577b9-54c0-4e71-b5bc-6a919093819b",
 InitializationCell->True],
Cell[44065, 819, 180, 3, 36, "Text",ExpressionUUID->"6b677ffa-4d4c-4bdb-bdc8-3199f382d3fd"],
Cell[44248, 824, 6790, 155, 163, "Input",ExpressionUUID->"c0a2ad95-eb1b-485e-928b-017df7a3b150",
 InitializationCell->True],
Cell[51041, 981, 7315, 166, 531, "Input",ExpressionUUID->"9fff71ad-812a-4932-bbfb-1ff310584aef",
 InitializationCell->True],
Cell[58359, 1149, 11060, 152, 47, "Input",ExpressionUUID->"e538eff8-6b5e-429d-8880-74d9dd7cafd3",
 InitializationCell->True]
}, Open  ]]
}
]
*)

